scala.tools.nsc.ast.parser

# SyntaxAnalyzer

###
Related Doc: package parser

#### abstract class SyntaxAnalyzer extends SubComponent with Parsers with MarkupParsers with Scanners with JavaParsers with JavaScanners

An nsc sub-component.

Source
  SyntaxAnalyzer.scala

Linear Supertypes
JavaParsers, JavaScanners, Parsers, ParsersCommon, MarkupParsers, Scanners, ScannersCommon, SubComponent, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. SyntaxAnalyzer
2. JavaParsers
3. JavaScanners
4. Parsers
5. ParsersCommon
6. MarkupParsers
7. Scanners
8. ScannersCommon
9. SubComponent
10. AnyRef
11. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new SyntaxAnalyzer()

### Type Members

1. #### abstract class AbstractJavaScanner extends AbstractJavaTokenData

   ...

   ...

   Definition Classes
     JavaScanners

2. #### abstract class AbstractJavaTokenData extends AnyRef

   Definition Classes
     JavaScanners

3. #### trait CommonTokenData extends AnyRef

   Definition Classes
     ScannersCommon

4. #### case class JavaOpInfo(operand: Global.Tree, operator: Global.Name, pos: Int) extends Product with Serializable

   Definition Classes
     JavaParsers

5. #### abstract class JavaParser extends ParserCommon

   Definition Classes
     JavaParsers

6. #### abstract class JavaScanner extends AbstractJavaScanner with JavaTokenData with Cloneable with ScannerCommon

   A scanner for Java.

   A scanner for Java.

   Definition Classes
     JavaScanners

7. #### trait JavaTokenData extends AbstractJavaTokenData

   A class for representing a token's data.

   A class for representing a token's data.

   Definition Classes
     JavaScanners

8. #### class JavaUnitParser extends JavaParser

   Definition Classes
     JavaParsers

9. #### class JavaUnitScanner extends JavaScanner

   Definition Classes
     JavaScanners

10. #### type Location = Int

    Definition Classes
      Parsers

11. #### class MalformedInput extends Exception

    Definition Classes
      Scanners

12. #### class MarkupParser extends MarkupParserCommon

    Definition Classes
      MarkupParsers

13. #### abstract class MemberDefTraverser extends Global.Traverser

14. #### class MemberPosReporter extends MemberDefTraverser

15. #### type Offset = Int

    Offset into source character array

    Offset into source character array

    Definition Classes
      ScannersCommon

16. #### case class OpInfo(lhs: Global.Tree, operator: Global.TermName, targs: List[Global.Tree], offset: Parsers.Offset) extends Product with Serializable

    Definition Classes
      Parsers

17. #### class OutlineParser extends SourceFileParser

    Definition Classes
      Parsers

18. #### class ParensAnalyzer extends UnitScanner

    Definition Classes
      Scanners

19. #### abstract class Parser extends ParserCommon

    Definition Classes
      Parsers

20. #### abstract class ParserCommon extends AnyRef

    This is now an abstract class, only to work around the optimizer: methods in traits are never inlined.

    This is now an abstract class, only to work around the optimizer: methods in traits are never inlined.

    Definition Classes
      ParsersCommon

21. #### class ParserPhase extends StdPhase

22. #### abstract class Scanner extends CharArrayReader with TokenData with ScannerData with ScannerCommon

    Definition Classes
      Scanners

23. #### trait ScannerCommon extends CommonTokenData

    Definition Classes
      ScannersCommon

24. #### trait ScannerData extends TokenData with CharArrayReaderData

    An interface to most of mutable data in Scanner defined in TokenData and CharArrayReader (+ next, prev fields) with copyFrom functionality to backup/restore data (used by quasiquotes' lookingAhead).

    An interface to most of mutable data in Scanner defined in TokenData and CharArrayReader (+ next, prev fields) with copyFrom functionality to backup/restore data (used by quasiquotes' lookingAhead).

    Definition Classes
      Scanners

25. #### class SourceFileParser extends Parser

    Definition Classes
      Parsers

26. #### class SourceFileScanner extends Scanner

    A scanner for a given source file not necessarily attached to a compilation unit.

    A scanner for a given source file not necessarily attached to a compilation unit. Useful for looking inside source files that aren not currently compiled to see what's there

    Definition Classes
      Scanners

27. #### abstract class StdPhase extends GlobalPhase

    A standard phase template

    A standard phase template

    Definition Classes
      SubComponent

28. #### type Token = Int

    Definition Classes
      ScannersCommon

29. #### trait TokenData extends CommonTokenData

    Definition Classes
      Scanners

30. #### class UnitParser extends SourceFileParser

    Definition Classes
      Parsers

31. #### class UnitScanner extends SourceFileScanner

    A scanner over a given compilation unit

    A scanner over a given compilation unit

    Definition Classes
      Scanners

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     JavaParsers → JavaScanners → ParsersCommon → ScannersCommon

2. #### abstract val runsAfter: List[String]

   Names of phases that must run before this phase.

   Names of phases that must run before this phase.

   Definition Classes
     SubComponent

3. #### abstract val runsRightAfter: Option[String]

   Name of the phase that this phase must follow immediately.

   Name of the phase that this phase must follow immediately.

   Definition Classes
     SubComponent

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from SyntaxAnalyzer to any2stringadd[SyntaxAnalyzer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (SyntaxAnalyzer, B)

   Implicit information
     This member is added by an implicit conversion from SyntaxAnalyzer to ArrowAssoc[SyntaxAnalyzer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object ConfusedAboutBracesControl extends Throwable with ControlThrowable with Product with Serializable

   Definition Classes
     MarkupParsers

7. #### final val InBlock: Location

   Definition Classes
     Parsers

8. #### final val InTemplate: Location

   Definition Classes
     Parsers

9. #### object JavaScannerConfiguration

   Definition Classes
     JavaScanners

10. #### final val Local: Location

    Definition Classes
      Parsers

11. #### object MissingEndTagControl extends Throwable with ControlThrowable with Product with Serializable

    Definition Classes
      MarkupParsers

12. #### lazy val ScalaValueClassNames: collection.Seq[Global.TypeName]

    Definition Classes
      Parsers

13. #### object TruncatedXMLControl extends Throwable with ControlThrowable with Product with Serializable

    Definition Classes
      MarkupParsers

14. #### final def afterOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

15. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

16. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

17. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

18. #### def createKeywordArray(keywords: Seq[(Global.Name, Token)], defaultToken: Token): (Token, Array[Token])

    Definition Classes
      ScannersCommon

19. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

20. #### def ensuring(cond: (SyntaxAnalyzer) ⇒ Boolean, msg: ⇒ Any): SyntaxAnalyzer

    Implicit information
      This member is added by an implicit conversion from SyntaxAnalyzer to Ensuring[SyntaxAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: (SyntaxAnalyzer) ⇒ Boolean): SyntaxAnalyzer

    Implicit information
      This member is added by an implicit conversion from SyntaxAnalyzer to Ensuring[SyntaxAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### def ensuring(cond: Boolean, msg: ⇒ Any): SyntaxAnalyzer

    Implicit information
      This member is added by an implicit conversion from SyntaxAnalyzer to Ensuring[SyntaxAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

23. #### def ensuring(cond: Boolean): SyntaxAnalyzer

    Implicit information
      This member is added by an implicit conversion from SyntaxAnalyzer to Ensuring[SyntaxAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

24. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

25. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

26. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

27. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from SyntaxAnalyzer to StringFormat[SyntaxAnalyzer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

28. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

29. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    returns

      the hash code value for this object.

    Definition Classes
      SubComponent → AnyRef → Any

30. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

31. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

32. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

33. #### def literalUnit: Global.Literal

    Definition Classes
      ParsersCommon

34. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### def newLiteral(const: Any): Global.Literal

    Definition Classes
      ParsersCommon

36. #### def newPhase(prev: Phase): StdPhase

    The phase factory

    The phase factory

    Definition Classes
      SyntaxAnalyzer → SubComponent

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### def ownPhase: Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

40. #### val phaseName: String

    The name of the phase

    The name of the phase

    Definition Classes
      SyntaxAnalyzer → SubComponent

41. #### def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent

42. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

43. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

44. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

45. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

46. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

47. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

48. #### final val token2name: Map[Int, Global.Name]

    Definition Classes
      Scanners

49. #### def token2string(token: Token): String

    Returns the string representation of given token.

    Returns the string representation of given token.

    Definition Classes
      Scanners

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### def →[B](y: B): (SyntaxAnalyzer, B)

    Implicit information
      This member is added by an implicit conversion from SyntaxAnalyzer to ArrowAssoc[SyntaxAnalyzer] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from JavaParsers

### Inherited from JavaScanners

### Inherited from Parsers

### Inherited from ParsersCommon

### Inherited from MarkupParsers

### Inherited from Scanners

### Inherited from ScannersCommon

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from SyntaxAnalyzer to any2stringadd[SyntaxAnalyzer]

### Inherited by implicit conversion StringFormat from SyntaxAnalyzer to StringFormat[SyntaxAnalyzer]

### Inherited by implicit conversion Ensuring from SyntaxAnalyzer to Ensuring[SyntaxAnalyzer]

### Inherited by implicit conversion ArrowAssoc from SyntaxAnalyzer to ArrowAssoc[SyntaxAnalyzer]

### Ungrouped